--megadott ponthoz (startpoint) vektort ad, a vektort a hossza mterben (distmeter), s szaktl val eltrse fokban (azimuth) jellemzi
CREATE function [dbo].[coAddVector](@startpoint geography, @distmeter float, @azimuth float) returns geography as
begin
declare @res geography;
declare @b float;
declare @a float;
declare @earthradius float;
declare @rlat1 float;
declare @rlon1 float;
declare @rlat2 float;
declare @rlon2 float;
declare @b2 float;
		set @earthradius =  6371000; -- fld sugara
		set @b = @distmeter / @earthradius;  
		set @rlat1 = radians(@startpoint.Lat);  --kezdpont koordinti radinban
		set @rlon1 = radians(@startpoint.Long);

		--j pont koordintinak kiszmtsa
		set @a = acos(cos(@b)*cos(PI()/2 - @rlat1) + sin(PI()/2 - @rlat1)*sin(@b)*cos(radians(@azimuth)));
		set @b2 = asin(sin(@b)*sin(radians(@azimuth))/sin(@a));
		set @rlat2 = PI()/2 - @a;
		set @rlon2 = @b2 + @rlon1; 
		
		--kapott eredmny koordintk radinbl fokra alaktsa, s geography tpuss alaktsa 4326-os (WSG84) vetletben
		SET @res = geography::Point(degrees(@rlat2), degrees(@rlon2), 4326);
	return @res;
end
GO

--szaktl val eltrs kiszmtsa kt koordintapr kztt hzd vektorra
CREATE function [dbo].[coAzimuth](@lat1 float, @lon1 float, @lat2 float, @lon2 float) returns float as
begin
declare @res float;
declare @rlat1 float;
declare @rlat2 float;
declare @dlon float;
declare @x float;
declare @y float;

	-- fokok tszmtsa radinba
	set @rlat1 = RADIANS(@lat1);
	set @rlat2 = RADIANS(@lat2);
	set @dlon = RADIANS(@lon2 - @lon1);

	--kiszmt algoritmus
    set @y = Sin(@dLon) * Cos(@rlat2);
    set @x = Cos(@rlat1) * Sin(@rlat2) - Sin(@rlat1) * Cos(@rlat2) * Cos(@dLon);

	--eredmny fokba alaktsa
    set @res = Degrees(Atn2(@y, @x));

	return @res;
end
GO

--adott szakaszon (line) a szakasz kezdpontjtl meghatrozott, adott tvolsgra (dist) lev pont kiszmtsa
CREATE function [dbo].[CalcDistanceOnLine](@line geography, @dist float)returns geography
begin
	declare @res geography;
	declare @i int;
	declare @prev int;
	declare @len float;
	declare @len2 float;
	declare @lastlen float;
	declare @point geography;
	declare @lastpoint geography;
	declare @azimuth float;

--ha a tvolsg hosszabb, mint a szakasz, a szakasz utols pontjt adja vissza
	if(@dist >= @line.STLength())
		set @res = @line.STPointN(@line.STNumPoints());
	else
	begin
		set @i = 2;
		set @prev = -1;
		set @len = 0;
		set @lastlen = 0;
		set @lastpoint = @line.STPointN(1);

-- addig megy a ciklus, amg a mrt hossz kisebb, mint a megadott hossz
		while(@i <= @line.STNumPoints() and @len <= @dist)
		begin
			set @point = @line.STPointN(@i);
			set @lastlen = @len;
			set @len = @len + @lastpoint.STDistance(@point);
			-- a szakasz elz pontjtl mri a tvolsgot az aktulis pontjig, majd hozzadja az eddig mrt hosszhoz
			set @lastpoint = @point;
			set @i = @i + 1;
		end

		if(@lastlen = @dist)
		begin
		--ha pontosan egyezik a mrt hossz a paramterben kapott hosszal, akkor a vizsglt utols pont az eredmny
			set @res = @line.STPointN(@i - 1);
		end
		else
		begin
		--egybknt r kell mrni az utols pontra egy vektort, ami
		--hossza a paramterben megadott hossz s az eddig mrt hossz klnbsge
		--szaktl val eltrse az utols eltti s utols pont ltal meghatrozott vektor szaktl val eltrse
			set @lastpoint = @line.STPointN(@i - 2);
			set @point = @line.STPointN(@i - 1);
			set @azimuth = dbo.coAzimuth(@lastpoint.Lat, @lastpoint.Long, @point.Lat, @point.Long);
			set @len2 = @dist - @lastlen;
			set @res = dbo.coAddVector(@lastpoint, @len2, @azimuth);
		end
	end
	return @res;
end

GO


